/*
 **************************************************************************
 *		SWI-Prolog ActiveX Extensions.
 *
 *	This software is provided in source and binary form free of charge to 
 *  users of SWI-Prolog.  No warranty of any kind is expressed or implied;
 *  in particular, this is entirely unsupported software.
 *
 *  Documentation for this product is available from the SWI-Prolog 
 *  web site (http://www.swi.psy.uva.nl/projects/SWI-Prolog/).
 *
 *	Version 1.0.1.
 *
 *	October 1, 1999
 *
 **************************************************************************
 */

//  declcom.h : helpful COM-oriented stuff

#pragma once
#include <comdef.h>
#include <functional>
using namespace std;

// Declarations of smart COM pointers using implicit COM classes
//  Smart pointer for objects which are #imported
#define DECL_IP_I(_T) DECL_IP_BASE(_T, __uuidof(_T) )
//  Smart pointer for objects which are #included (such as DaVinci);
//		assumes that each interface name XXX has corresponding IID_XXX.
#define DECL_IP_H(_T) DECL_IP_BASE(_T, IID_##_T)
//  Smart pointer for arbitrary interface pointer
#define DECL_IP_U(_T,_IID) DECL_IP_BASE(_T,_IID)

#define DECL_IP_BASE(_T,_IID) typedef _com_ptr_t< _com_IIID<_T, & _IID> > IP_##_T;

template< class _CIID > 
bool operator ! ( const _com_ptr_t< _CIID > & ip )
{
	return ip == NULL;
}

DECL_IP_H(IUnknown)


//  T_IPLESS: 'less' template for use in maps

template <typename _T, const IID * _PIID>
struct T_IPLESS : 
	binary_function< _com_ptr_t< _com_IIID<_T, _PIID> >, _com_ptr_t< _com_IIID<_T, _PIID> >, bool >
{
	bool operator() ( const _com_ptr_t< _com_IIID<_T, _PIID> > & _X, 
					  const _com_ptr_t< _com_IIID<_T, _PIID> > & _Y ) const
	{
		IP_IUnknown ipUnkX( _X );
		IP_IUnknown ipUnkY( _Y );
		void * pvx = ipUnkX;
		void * pvy = ipUnkY;
		return pvx < pvy; 
	}
};

inline int CRef ( IUnknown * pUnk )
{
	pUnk->AddRef();
	return pUnk->Release();
}
